/*
	SNAPSHOT.C    							(c) 1997 by Till Harbaum
*/

#include <vdi.h>
#include <aes.h>
#include <stdio.h>
#include <tos.h>
#include <string.h>
#include <stdlib.h>

int 	work_in[12],work_out[57];
int 	handle,phys_handle;
int 	gl_hchar,gl_wchar,gl_hbox,gl_wbox;
int 	gl_apid,colors,width,height;

extern void GIFEncode(char *name, int a, int b, int c, int d, int e,
                    int f[], int g[], int h[], int( *i)(int a, int b) );

/* get the next pixel */
int get_pix(int x, int y) {
	int pel, index;
  v_get_pixel( handle, x, y, &pel, &index );
  return(index);
}

void grab_screen(void) {
	char name[128],path[128],file[16],*chr;
	int  i,but,col[3];
	int  red[256],green[256],blue[256];

	strcpy(path,"X:");
	path[0]=Dgetdrv()+'A';
	Dgetpath(&path[2],0);
	strcat(path,"\\*.GIF");

	fsel_input(path,file,&but);
	if(but!=0) {

		/* gib Fileselektor Zeit zu verschwinden */
		evnt_timer(1000,0);

		if((chr=strrchr(path,'\\'))!=NULL)
			*(chr+1)='\0';

		strcpy(name,path);
		strcat(name,file);

		for(i=0;i<colors;i++) {
			vq_color(handle,i,1,col);
			red[i]   = (int)(((long)col[0])*255/1000);
			green[i] = (int)(((long)col[1])*255/1000);
			blue[i]  = (int)(((long)col[2])*255/1000);
		}

	  GIFEncode(name,                /* file name */
           width, height,        	/* image size */
           0,                      /* no interlace */
           0,                      /* bkg color */
           8,                      /* bits per pixel */
           red, green, blue,       /* palette arrays */
           get_pix);            /* pixel function */
	}
	/* am Ende ping */
	putchar(7);
}

int main( void ) {
	int	i,menu_id,msg[16];
	
	if (( gl_apid = appl_init() ) != -1 ) {
		for ( i = 1; i < 10; work_in[i++] = 1 );
		work_in[10] = 2;
		phys_handle = graf_handle( &gl_wchar, &gl_hchar, &gl_wbox, &gl_hbox );
		work_in[0]  = handle = phys_handle;

		v_opnvwk( work_in, &handle, work_out );

		width  = work_out[0]+1;
		height = work_out[1]+1;
		colors = work_out[13];
		
    if ( !_app ) {
     	menu_id = menu_register( gl_apid, "  Snapshot" );

			for(;;)
			{
				evnt_mesag(msg);
				
				if((msg[0]==AC_OPEN)&&(msg[4]==menu_id))
					grab_screen();
			}
		} else {
      graf_mouse(ARROW,NULL);
   	  grab_screen();
   	}
		v_clsvwk( handle );
		appl_exit( );
 	}

	if( !_app ) for(;;);
	return(0);
}
